var Stream = require('stream'),
Erk = require('erk'),
Net = require('net');

Queue = require('./lib/queue').Queue,
PluginHandler = require('./lib/pluginHandler.js').PluginHandler;

var Igelkott = module.exports = function Igelkott(config) {
  Stream.Duplex.call(this, {
    objectMode: true
  });

  if ( ! config.plugins) throw new Error("config.plugins is not defined, igelkott is pointless without any plugins");
  this.config = config;

  this.parser = new Erk.Parser();
  this.composer = new Erk.Composer();
  this.queue = new Queue(this);
  this.plugin = new PluginHandler(this);

  this._read = function _read(size) {};

  this._write = function _write(message, enc, callback) {
    this.emit(message.command, message);
    this.queue.handleQueue(message);
    callback();
  };

  // Time to load some plugins.
  for (var plugin in this.config.plugins) {
    this.load(plugin, this.config.plugins[plugin]);
  }

  this.setUpServer(this.config.adapter || new Net.Socket());
  this.doConnect(this.config.connect || function() {
    this.server.connect(this.config.server.port, this.config.server.host);
  });
};

Igelkott.prototype = Object.create(Stream.Duplex.prototype, {
  constructor: {
    value: Igelkott
  }
});

Igelkott.prototype.load = function load(pluginName, config, plugin) {
  var config = config || this.config.plugins[pluginName] || {};
  var plugin = plugin || require(this.config.pluginPath + 'igelkott-'+pluginName).Plugin;

  try {
    this.plugin.load(pluginName, config, plugin);
  } catch (err)
  {
    console.log(err);
    this.error('No such plugin: '+pluginName);
  }
};

Igelkott.prototype.setUpServer = function setUpServer(server) {
  this.server = server;

  this.server.on('connect', function() {
    this.pipe(this.composer).pipe(this.server).pipe(this.parser).pipe(this);
    this.emit('connect');
  }.bind(this));
};

Igelkott.prototype.doConnect = function doConnect(doConnect) { this.connection = doConnect; };
Igelkott.prototype.log = function log() {};
Igelkott.prototype.error = function error() {};
Igelkott.prototype.connect = function connect() { this.connection(); };
Igelkott.prototype.end = function connect() { this.log('Time to sleep...'); };
